CodeForces 723E One-Way Reform

 

One-Way Reform

Description

There are n cities and m two-way roads in Berland, each road connects two cities. It is known that there is no more than one road connecting each pair of cities, and there is no road which connects the city with itself. It is possible that there is no way to get from one city to some other city using only these roads.

The road minister decided to make a reform in Berland and to orient all roads in the country, i.e. to make each road one-way. The minister wants to maximize the number of cities, for which the number of roads that begins in the city equals to the number of roads that ends in it.

Input

The first line contains a positive integer t (1 ≤ t ≤ 200) — the number of testsets in the input.

Each of the testsets is given in the following way. The first line contains two integers n and m (1 ≤ n ≤ 200, 0 ≤ m ≤ n·(n - 1) / 2) — the number of cities and the number of roads in Berland.

The next m lines contain the description of roads in Berland. Each line contains two integers u and v (1 ≤ u, v ≤ n) — the cities the corresponding road connects. It's guaranteed that there are no self-loops and multiple roads. It is possible that there is no way along roads between a pair of cities.

It is guaranteed that the total number of cities in all testset of input data doesn't exceed 200.

Pay attention that for hacks, you can only use tests consisting of one testset, so t should be equal to one.

Output

For each testset print the maximum number of such cities that the number of roads that begins in the city, is equal to the number of roads that ends in it.

In the next m lines print oriented roads. First print the number of the city where the road begins and then the number of the city where the road ends. If there are several answers, print any of them. It is allowed to print roads in each test in arbitrary order. Each road should be printed exactly once.

Sample Input

Input
2
5 5
2 1
4 5
2 3
1 3
3 5
7 2
3 7
4 2
Output
3
1 3
3 5
5 4
3 2
2 1
3
2 4
3 7

题意是给出一个无向图,求如何将该无向图变成有向图后使得出度等于入度的点最多,我们可以把新开一个节点,把度数为奇数的点连接到新节点上,然后求欧拉回路,由于这道题不需要输出路径,所以可以枚举每个点让这个点搜索到最深就能得到需要的图。
#include <bits/stdc++.h>
using namespace std;
const int maxn = 210;
int deg[maxn];
vector<int> g[maxn];
int vis[maxn];
void AddEdge(int u, int v) {
    g[u].emplace_back(v);
    deg[u]++;
}
int it[maxn];
set< pair<int, int> > st;

void dfs(int x) {
    while(it[x]<g[x].size()) {
        int v=g[x][it[x]];
        it[x]++;
        if(st.count({v,x})==1)continue;
        st.insert({x,v});
        dfs(v);
    }
}

int main() {
    int t;
    scanf("%d", &t);
    while(t--) {
        st.clear();
        memset(it, 0, sizeof(it));
        memset(vis, 0, sizeof(vis));
        memset(deg, 0, sizeof(deg));
        for(int i = 0; i < maxn; i++) g[i].clear();
        int n, m;
        scanf("%d %d", &n, &m);
        for(int i = 1; i <= m; i++) {
            int u, v;
            scanf("%d %d", &u, &v);
            AddEdge(u, v);
            AddEdge(v, u);
        }
        int ans = n;
        for(int i = 1; i <= n; i++) {
            //printf("check %d %d\n", i, deg[i]);
            if(deg[i] % 2 != 0) {
                ans--;
                AddEdge(0, i);
                AddEdge(i, 0);
            }
        }
        for(int i = 1; i <= n; i++) {
            if(!it[i]) dfs(i);
        }
        printf("%d\n", ans);
        for(auto x:st) {
            if(x.first && x.second) {
                printf("%d %d\n", x.first, x.second);
            }
        }
    }
}
 

 

posted @ 2016-10-07 17:02  MartinEden  阅读(310)  评论(0编辑  收藏  举报